package anywheresoftware.b4a.samples.camera;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "anywheresoftware.b4a.samples.camera", "anywheresoftware.b4a.samples.camera.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "anywheresoftware.b4a.samples.camera", "anywheresoftware.b4a.samples.camera.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.shellMode) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "anywheresoftware.b4a.samples.camera.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.ImageViewWrapper _imageview1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 29;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 31;BA.debugLine="Activity.LoadLayout(\"Layout1\")";
mostCurrent._activity.LoadLayout("Layout1",mostCurrent.activityBA);
 //BA.debugLineNum = 33;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 39;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 41;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 35;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 37;BA.debugLine="End Sub";
return "";
}
public static String  _button1_click() throws Exception{
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _btmp = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _rect1 = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper _c = null;
int _ambiencecolor = 0;
 //BA.debugLineNum = 80;BA.debugLine="Sub Button1_Click";
 //BA.debugLineNum = 81;BA.debugLine="Dim btmp As Bitmap";
_btmp = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 82;BA.debugLine="Dim rect1 As Rect";
_rect1 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();
 //BA.debugLineNum = 83;BA.debugLine="Dim c As Canvas";
_c = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 //BA.debugLineNum = 84;BA.debugLine="Dim ambiencecolor As Int";
_ambiencecolor = 0;
 //BA.debugLineNum = 85;BA.debugLine="btmp.Initialize(File.DirAssets,\"flower.png\")";
_btmp.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"flower.png");
 //BA.debugLineNum = 86;BA.debugLine="ambiencecolor=getambiencecolor(btmp,129,86,153,106)";
_ambiencecolor = _getambiencecolor(_btmp,BA.NumberToString(129),BA.NumberToString(86),BA.NumberToString(153),(int) (106));
 //BA.debugLineNum = 87;BA.debugLine="ImageView1.Bitmap=btmp";
mostCurrent._imageview1.setBitmap((android.graphics.Bitmap)(_btmp.getObject()));
 //BA.debugLineNum = 88;BA.debugLine="ImageView1.Width=btmp.Width";
mostCurrent._imageview1.setWidth(_btmp.getWidth());
 //BA.debugLineNum = 89;BA.debugLine="ImageView1.Height=btmp.Height";
mostCurrent._imageview1.setHeight(_btmp.getHeight());
 //BA.debugLineNum = 91;BA.debugLine="rect1.Initialize(10,10,50,50)";
_rect1.Initialize((int) (10),(int) (10),(int) (50),(int) (50));
 //BA.debugLineNum = 92;BA.debugLine="c.Initialize(ImageView1)";
_c.Initialize((android.view.View)(mostCurrent._imageview1.getObject()));
 //BA.debugLineNum = 93;BA.debugLine="c.DrawRect(rect1,ambiencecolor,True,1)";
_c.DrawRect((android.graphics.Rect)(_rect1.getObject()),_ambiencecolor,anywheresoftware.b4a.keywords.Common.True,(float) (1));
 //BA.debugLineNum = 94;BA.debugLine="End Sub";
return "";
}
public static int  _getambiencecolor(anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _b,String _x1,String _y1,String _x2,int _y2) throws Exception{
int[] _argb = null;
int _i = 0;
int _j = 0;
int _ta = 0;
int _tr = 0;
int _tg = 0;
int _tb = 0;
int _aa = 0;
int _ar = 0;
int _ag = 0;
int _ab = 0;
int _numberofpixel = 0;
int _ambiencecolor = 0;
int _ca = 0;
int _cr = 0;
int _cg = 0;
int _cb = 0;
int _colorvalue = 0;
 //BA.debugLineNum = 43;BA.debugLine="Sub getambiencecolor(b As Bitmap,x1,y1,x2,y2 As Int) As Int";
 //BA.debugLineNum = 44;BA.debugLine="Dim argb() As Int";
_argb = new int[(int) (0)];
;
 //BA.debugLineNum = 45;BA.debugLine="Dim i,j As Int";
_i = 0;
_j = 0;
 //BA.debugLineNum = 46;BA.debugLine="Dim ta,tr,tg,tb,aa,ar,ag,ab As Int";
_ta = 0;
_tr = 0;
_tg = 0;
_tb = 0;
_aa = 0;
_ar = 0;
_ag = 0;
_ab = 0;
 //BA.debugLineNum = 47;BA.debugLine="Dim numberofpixel,ambiencecolor As Int";
_numberofpixel = 0;
_ambiencecolor = 0;
 //BA.debugLineNum = 48;BA.debugLine="Dim ca,cr,cg,cb As Int";
_ca = 0;
_cr = 0;
_cg = 0;
_cb = 0;
 //BA.debugLineNum = 49;BA.debugLine="Dim colorvalue As Int";
_colorvalue = 0;
 //BA.debugLineNum = 51;BA.debugLine="ta=0";
_ta = (int) (0);
 //BA.debugLineNum = 52;BA.debugLine="tr=0";
_tr = (int) (0);
 //BA.debugLineNum = 53;BA.debugLine="tg=0";
_tg = (int) (0);
 //BA.debugLineNum = 54;BA.debugLine="tb=0";
_tb = (int) (0);
 //BA.debugLineNum = 55;BA.debugLine="numberofpixel=0";
_numberofpixel = (int) (0);
 //BA.debugLineNum = 56;BA.debugLine="For i=x1 To x2";
{
final int step25 = 1;
final int limit25 = (int)(Double.parseDouble(_x2));
for (_i = (int)(Double.parseDouble(_x1)); (step25 > 0 && _i <= limit25) || (step25 < 0 && _i >= limit25); _i = ((int)(0 + _i + step25))) {
 //BA.debugLineNum = 57;BA.debugLine="For j=y1 To y2";
{
final int step26 = 1;
final int limit26 = _y2;
for (_j = (int)(Double.parseDouble(_y1)); (step26 > 0 && _j <= limit26) || (step26 < 0 && _j >= limit26); _j = ((int)(0 + _j + step26))) {
 //BA.debugLineNum = 58;BA.debugLine="colorvalue=b.getPixel(i,j)";
_colorvalue = _b.GetPixel(_i,_j);
 //BA.debugLineNum = 59;BA.debugLine="argb = GetARGB(colorvalue)";
_argb = _getargb(_colorvalue);
 //BA.debugLineNum = 60;BA.debugLine="ca=argb(0)";
_ca = _argb[(int) (0)];
 //BA.debugLineNum = 61;BA.debugLine="cr=argb(1)";
_cr = _argb[(int) (1)];
 //BA.debugLineNum = 62;BA.debugLine="cg=argb(2)";
_cg = _argb[(int) (2)];
 //BA.debugLineNum = 63;BA.debugLine="cb=argb(3)";
_cb = _argb[(int) (3)];
 //BA.debugLineNum = 64;BA.debugLine="ta=ta+ca";
_ta = (int) (_ta+_ca);
 //BA.debugLineNum = 65;BA.debugLine="tr=tr+cr";
_tr = (int) (_tr+_cr);
 //BA.debugLineNum = 66;BA.debugLine="tg=tg+cg";
_tg = (int) (_tg+_cg);
 //BA.debugLineNum = 67;BA.debugLine="tb=tb+cb";
_tb = (int) (_tb+_cb);
 //BA.debugLineNum = 68;BA.debugLine="numberofpixel=numberofpixel+1";
_numberofpixel = (int) (_numberofpixel+1);
 }
};
 }
};
 //BA.debugLineNum = 71;BA.debugLine="aa=ta/numberofpixel";
_aa = (int) (_ta/(double)_numberofpixel);
 //BA.debugLineNum = 72;BA.debugLine="ar=tr/numberofpixel";
_ar = (int) (_tr/(double)_numberofpixel);
 //BA.debugLineNum = 73;BA.debugLine="ag=tg/numberofpixel";
_ag = (int) (_tg/(double)_numberofpixel);
 //BA.debugLineNum = 74;BA.debugLine="ab=tb/numberofpixel";
_ab = (int) (_tb/(double)_numberofpixel);
 //BA.debugLineNum = 75;BA.debugLine="ambiencecolor=Colors.argb(aa,ar,ag,ab)";
_ambiencecolor = anywheresoftware.b4a.keywords.Common.Colors.ARGB(_aa,_ar,_ag,_ab);
 //BA.debugLineNum = 76;BA.debugLine="Msgbox(ambiencecolor,11)";
anywheresoftware.b4a.keywords.Common.Msgbox(BA.NumberToString(_ambiencecolor),BA.NumberToString(11),mostCurrent.activityBA);
 //BA.debugLineNum = 77;BA.debugLine="Return ambiencecolor";
if (true) return _ambiencecolor;
 //BA.debugLineNum = 78;BA.debugLine="End Sub";
return 0;
}
public static int[]  _getargb(int _color) throws Exception{
int[] _res = null;
 //BA.debugLineNum = 96;BA.debugLine="Sub GetARGB(Color As Int) As Int()";
 //BA.debugLineNum = 97;BA.debugLine="Dim res(4) As Int";
_res = new int[(int) (4)];
;
 //BA.debugLineNum = 98;BA.debugLine="res(0) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff000000), 24)";
_res[(int) (0)] = anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_color,(int) (0xff000000)),(int) (24));
 //BA.debugLineNum = 99;BA.debugLine="res(1) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff0000), 16)";
_res[(int) (1)] = anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_color,(int) (0xff0000)),(int) (16));
 //BA.debugLineNum = 100;BA.debugLine="res(2) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff00), 8)";
_res[(int) (2)] = anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_color,(int) (0xff00)),(int) (8));
 //BA.debugLineNum = 101;BA.debugLine="res(3) = Bit.AND(Color, 0xff)";
_res[(int) (3)] = anywheresoftware.b4a.keywords.Common.Bit.And(_color,(int) (0xff));
 //BA.debugLineNum = 102;BA.debugLine="Return res";
if (true) return _res;
 //BA.debugLineNum = 103;BA.debugLine="End Sub";
return null;
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 25;BA.debugLine="Dim ImageView1 As ImageView";
mostCurrent._imageview1 = new anywheresoftware.b4a.objects.ImageViewWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Dim Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 27;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
}
